#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
#include <bits/stdc++.h>

using namespace std;
typedef long long LL;

const int MOD = 1000000007;

struct Mat {
	LL a[2][2];
	Mat () {
		a[0][0] = a[1][1] = 1;
		a[0][1] = a[1][0] = 0;
	}
} C;
Mat operator * ( const Mat&a, const Mat& b ) {
	Mat ret;
	ret.a[0][0] = ( a.a[0][0] * b.a[0][0] + a.a[0][1] * b.a[1][0] ) % MOD;
	ret.a[0][1] = ( a.a[0][0] * b.a[0][1] + a.a[0][1] * b.a[1][1] ) % MOD;
	ret.a[1][0] = ( a.a[1][0] * b.a[0][0] + a.a[1][1] * b.a[1][0] ) % MOD;
	ret.a[1][1] = ( a.a[1][0] * b.a[0][1] + a.a[1][1] * b.a[1][1] ) % MOD;
	return ret;
}

Mat modExp( Mat a, LL n ) {
	Mat ret;
	for( ; n; n >>= 1, a = a * a )	if( n & 1 )	ret = ret * a;
	return ret;
}

LL get( LL n ) {
	if( n == 0 )	return 0;
	if( n == 1 )	return 1;
	Mat t = modExp(C, n-1);
	return t.a[0][0];
}

LL solve( LL n ) {
	LL a = get(n+1) - 2 * get(n);
	a = (a % MOD + MOD) % MOD;
	return a;
}

int main() {
	LL n;
	int tcase;
	scanf("%d", &tcase );
	C.a[0][0] = 7,	C.a[0][1] = -4;
	C.a[1][0] = 1,	C.a[1][1] = 0;
	while( tcase-- ) {
		scanf(INT64, &n );
		printf(INT64 "\n", solve(n) );
	}
	return 0;
}
